#!/bin/sh

# First check that we *have* clisp
clisp -q -q -x '(quit)' || exit 77

top_builddir=${top_builddir:-..}
export top_builddir

\rm -f Context[123] .Context[123].tmp 2>/dev/null
exec 2>/dev/null # To drop job control messages
echo '#ST_IGNORE:^Exiting on signal'
$top_builddir/util/cr_run/cr_run clisp -q -q -x '
    (progn
	(defun greet (n)
	    (format t "~D equals ~R~%" n n)
	    (sleep 1)
	    (if (< n 9) (greet (+ n 1))))
	(greet 0)
	(format t "# Checkpointing self~%")
	(ext:execute
	    (format nil "~a/util/cr_checkpoint/cr_checkpoint" (ext:getenv "top_builddir"))
	    "--file=Context3" "--term" "--tree" (write-to-string (process-id)))
	(format t "11 DONE~%")
	(quit))' 2>&1 &
pid=$!
sleep 3
echo "# Checkpoint original child"
$top_builddir/util/cr_checkpoint/cr_checkpoint --file=Context1 --term $pid 2>&1
wait
sleep 1
echo "# Restart 1"
$top_builddir/util/cr_restart/cr_restart Context1 2>&1 &
pid=$!
sleep 3
echo "# Checkpoint restarted child"
$top_builddir/util/cr_checkpoint/cr_checkpoint --file=Context2 --term --tree $pid 2>&1
wait
sleep 1
echo "# Restart^2"
$top_builddir/util/cr_restart/cr_restart Context2 2>&1 &
pid=$!
wait
echo "10 Restart interpreter"
$top_builddir/util/cr_restart/cr_restart Context3 2>&1
\rm -f Context[123] .Context[123].tmp 2>/dev/null
